SCREEN 0
DefNewChar(160,@NEWCHAR0)
DefNewChar(161,@NEWCHAR1)
DefNewChar(162,@NEWCHAR2)
DefNewChar(163,@NEWCHAR3)
DefNewChar(164,@NEWCHAR4)
DefNewChar(165,@NEWCHAR5)
DefNewChar(166,@NEWCHAR6)
DefNewChar(167,@NEWCHAR7)
DefNewChar(168,@NEWCHAR8)
DefNewChar(169,@NEWCHAR9)
DefNewChar(170,@NEWCHAR10)
DefNewChar(171,@NEWCHAR11)
DefNewChar(172,@NEWCHAR12)
DefNewChar(173,@NEWCHAR13)
DefNewChar(174,@NEWCHAR14)
DefNewChar(175,@NEWCHAR15)
Dim TempWord As Word
Dim FileName As String(40)="ELFMON.BIN"
Gosub Get1802File
CHIP16BEGIN
> SHOM
> HIDM
> MOVE R00 = #0000   ;Set horizontal + Vertical max
> MOVE R01 = #03FF
> STHM R00 R01       ;Set x=128*8
> MOVE R01 = #017F
> STVM R00 R01       ;Set y=48*8
CHIP16END
Dim SimSpeed As Word=512	'Default about 1/2 sec delay
Dim BreakPoint As Word=65535
RefreshMainScreen:
Dim Reg(15) As Word
For i=0 To 15
  Reg(i)=0
Next
Dim RegI As Byte=0
Dim RegN As Byte=0
Dim RegP As Byte=0
Dim RegX As Byte=0
Dim RegT As Byte
Dim RegDAcc As Byte
Dim RegDF As Byte=0
Dim RegQ As Byte=0
Dim RegIE As Byte=1
'NOTE:using 16K of Segment E for memory
Dim MemoryBytes(16384) As Byte
Dim CPUBusValue As Byte=0
Dim CPU_NLines As Byte=0

'-------------------------------------
' Memory Cycle Types                 |
'-------------------------------------
' Non-memory cycle   = 1             |
' Memory write cycle = 2             |
' Memory read cycle  = 3             |
' Long branch or long skip cycle = 4 |
Dim MemCycleType As Byte

'-----------------------------------
' State Code Types | Statcode Lines|
'                  | SC1 | SC0 |
'-----------------------------------
' S0 (Fetch)       |  L  |  L  |
'-----------------------------------
' S1 (Execute)     |  L  |  H  |
'-----------------------------------
' S2 (DMA)         |  H  |  L  |
'-----------------------------------
' S3 (Interrupt)   |  H  |  H  |
'-----------------------------------
Dim StateCode As Byte=1

'----------------------
' Mode | CLEAR | WAIT |
'----------------------
'RESET |   0   |   1  |
'----------------------
'LOAD  |   0   |   0  |
'----------------------
'PAUSE |   1   |   0  |
'----------------------
'RUN   |   1   |   1  |
'----------------------
Dim ModeControl As Byte=1
Dim CLKPulseCount As Byte=0
Dim LongBranchFlag As Byte
Dim TPAPulse As Byte=0
Dim TPBPulse As Byte=0
Dim MRDPulse As Byte=1
Dim MWRPulse As Byte=1
Dim EFLAG1 As Byte=0
Dim EFLAG2 As Byte=0
Dim EFLAG3 As Byte=0
Dim EFLAG4 As Byte=0
Dim MathOperVal As SWord
Dim KeyPadVal As Byte
Dim LEDVal As Byte
Dim DMAINPulse As Byte=1
Dim DMAIN_INTFlag As Byte=0
Dim DMAOUTPulse As Byte=1
Dim DMAOUT_INTFlag As Byte=0
Dim INTPulse As Byte=1
Dim LCAT_Val As Byte
Dim CDP1861IntStartFlag As Byte = 0
Dim CDP1861IntFlag As Byte = 0
Dim CDP1861Visible As Byte=0
Dim scanline As Byte=0
Dim BigScrollMemPos As Word=3
Dim CPUMemAdd As Word=0
Dim CPUMemAddHIGH As Byte=0
Dim CPUMemAddLOW As Byte=0
CLS
Gosub DrawMenuBar
Dim BoxChars As String(6)=CHR($C9) & CHR($BB) & CHR($BC) & CHR($C8) & CHR($CD) & CHR($BA)
Gosub DrawMemoryLocationBox
TLCx=60
TLCy=1
BRCx=127
BRCy=11
BoxTitle="Scratch Pad and CPU Registers"
Color(15)
Gosub DrawBox
Print At 117,2,"BRK=";
Print At 62,3,"R0=     R1=     R2=     R3=     R4=     R5=     R6=     R7=";
Print At 62,4,"R8=     R9=     RA=     RB=     RC=     RD=     RE=     RF=";
Print At 62,6,"I=    N=    P=    X=    T=     D=     DF=    Q=    IE=    KP=";
Print At 62,8,"DB=    MA=      SC=   Clk=   DMAIN=   DMAOUT=   INT=   LED=";
Print At 62,10,"TPA=   TPB=   MRD=   MWR=   NLines=   EF1=   EF2=   EF3=   EF4=";
Dim NibbleStr As String(3)=CHR($5F) & CHR($5F) & CHR($5F)
Print At 91,7,NibbleStr,LEFT(NibbleStr,2);
Print At 100,[V04],NibbleStr,NibbleStr;
Print At 110,[V04],NibbleStr;
Print At 76,9,NibbleStr;
Print At 83,[V04],NibbleStr;
Print At 100,[V04],NibbleStr;
Print At 107,[V04],NibbleStr;
Print At 114,[V04],NibbleStr;
Print At 121,[V04],NibbleStr;
Gosub UpdateRegisters
Gosub GetMouse1
Dim SavemouseX As Byte=[R02]
Dim SavemouseY As Byte=[R03]
Gosub GetCharAndAtribute
Print At mouseX,mouseY,CHR($DB);
Dim Key As Byte
DefMemPtr(ML4)=@_KEYSHIFTSTATUS
DefMemPtr(ML5)=@_SCANKEYCODE
DefMemPtr(ML6)=@_VALIDCODE

Main:
Dim Operation As Byte=0
Do While Operation=0
  If Inkey='F' Then
    Gosub GetKeyBdShiftStatus
    If Key=8 Then
      [V0B]=1
      Goto _Br_File_Menu_Operation
    End If
  End If
  If Inkey='R' Then
    Gosub GetKeyBdShiftStatus
    If Key=8 Then
      [V0B]=1
      Goto _Br_Run_Menu_Operation
    End If
  End If
  Dim [V0B] As Byte=0
  Dim [R02] As Word
  Dim [R03] As Word
  Gosub GetMouse2
  If [V0B]=1 Then
    'Left Mouse Button
    If mouseY=0 Then
      'A menu Operation was selected
      If mouseX>0 And mouseX<5 Then
        'File Menu Operation
_Br_File_Menu_Operation:
        Do While [V0B]=1
          Color Blue,Bright White
          Print At 1,0,"File";
          CHIP16BEGIN
          > GETM R02 R03 V0B
          CHIP16END
        Loop
        Color Green,Bright White
        TLCx=0
        TLCy=3
        BRCx=57
        BRCy=9
        BoxTitle="Enter Filename"
        BoxChars=CHR($DA) & CHR($BF) & CHR($D9) & CHR($C0) & CHR($C4) & CHR($B3)
        Gosub DrawBox
        Print At 0,5,CHR($C3),STRDUP(56,CHR($C4)),CHR($B4);
        Print At 1,6,"NOTES:To cancel,just leave entry blank and press <ENTER>";
        Print At 1,7,"      To open a file in another location, make sure to  ";
        Print At 1,8,"      enter a valid DOS path name (d:\folder\)(..\).    ";
        Print At 1,4,STRDUP(56," ");
        Call _FlushKeybdBuffer
        Color Green,Yellow
        Dim SaveFilename As String=FileName
        Input At 2,4,FileName
        If FileName<>"" Then
          Gosub Get1802File
        End If
        If fOpenError = $EE Or FileName="" Then
          FileName=SaveFilename
        End If
        Goto RefreshMainScreen
      End If
      If mouseX>6 And mouseX<10 Then
        'Run Menu Operation
_Br_Run_Menu_Operation:
        Color Blue,Bright White
        Print At 7,0,"Run";
        Do While [V0B]=1 Or Key=8
          CHIP16BEGIN
          > GETM R02 R03 V0B
          CHIP16END
          Gosub GetKeyBdShiftStatus
        Loop
        StateCode=0
        Color Blue,Yellow
        NibbleStr=CSTR(StateCode)
        Print At 81,8,RIGHT(NibbleStr,1);
_Br_Run_Menu_Operation2:
        Color Cyan,Black
        Print At 2,0,"eset   ingleCycle   lockPulse   o";
        Color Cyan,Red
        Print At 1,[V04],"R";
        Print At 8,[V04],"S";
        Print At 21,[V04],"C";
        Print At 33,[V04],"G";
        If mouseY=0 Then
          Gosub GetCharAndAtribute
        End If
        ModeControl=3
        Operation=11
        Do While Operation<20
          Call _GETKEY
          Dim ValidCode As Byte
          Dim ScanKeyCode As Word
          ValidCode=Peek(6)
          ScanKeyCode=Peek(5)
          If ValidCode = 255 Then
            If ScanKeyCode=$3B00 Then
              'F1 Key
              EFLAG1=EFLAG1 Xor 1
              NibbleStr=CSTR(EFLAG1)
              Print At 104,10,RIGHT(NibbleStr,1);
            Else
              If ScanKeyCode=$3C00 Then
                'F2 Key
                EFLAG2=EFLAG2 Xor 1
                NibbleStr=CSTR(EFLAG2)
                Print At 111,10,RIGHT(NibbleStr,1);
              Else
                If ScanKeyCode=$3D00 Then
                  'F3 Key
                  EFLAG3=EFLAG3 Xor 1
                  NibbleStr=CSTR(EFLAG3)
                  Print At 118,10,RIGHT(NibbleStr,1);
                Else
                  If ScanKeyCode=$3E00 Then
                    'F4 Key
                    EFLAG4=EFLAG4 Xor 1
                    NibbleStr=CSTR(EFLAG4)
                    Print At 125,10,RIGHT(NibbleStr,1);
                  Else
                    If ScanKeyCode=$3F00 Then
                      'F5 Key
                      DMAINPulse=DMAINPulse Xor 1
                      NibbleStr=CSTR(DMAINPulse)
                      Print At 97,8,RIGHT(NibbleStr,1);
                      If DMAINPulse=0 Then
                        DMAIN_INTFlag = 255
                      Else
                        DMAIN_INTFlag = 0
                      End If
                    Else
                      If ScanKeyCode=$4000 Then
                        'F6 Key
                        DMAOUTPulse=DMAOUTPulse Xor 1
                        NibbleStr=CSTR(DMAOUTPulse)
                        Print At 107,8,RIGHT(NibbleStr,1);
                        If DMAOUTPulse=0 Then
                          DMAOUT_INTFlag = 255
                        Else
                          DMAOUT_INTFlag = 0
                        End If
                      Else
                        If ScanKeyCode=$4100 Then
                          'F7 Key
                          INTPulse=INTPulse Xor 1
                          NibbleStr=CSTR(INTPulse)
                          Print At 114,8,RIGHT(NibbleStr,1);
                        Else
                          Key=ScanKeyCode And 255
                          ScanKeyCode=ScanKeyCode SHIFT>> 8
                          If ScanKeyCode>1 And ScanKeyCode<12 Or Key>$60 And Key<$67 Then
                            mouseX=123
                            mouseY=6
                            Gosub RightMouseButton
                          End If
                        End If
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
          Gosub GetMouse2
          If [V0B]=1 Then
            Gosub ScrollBar
            If mouseY=0 Then
              If mouseX>0 And mouseX<6 Then
                Goto _Br_Reset_Menu_Operation
              End If
              If Operation=11 Then
                If mouseX>7 And mouseX<19 Then
                  Gosub SingleCycleSelected
                End If
                If mouseX>20 And mouseX<31 Then
                  Gosub ClockPulseSelected
                End If
                If mouseX>32 And mouseX<35 Then
                  Gosub GoSelected
                End If
              End If
              If Operation=12 Then
                If mouseX>7 And mouseX<12 Then
                  Gosub StopSelected
                  Goto _Br_Run_Menu_Operation2
                End If
              End If
            End If
          End If
          If [V0B]=2 Then
            Gosub RightMouseButton
          End If
          If Operation=12 Then
            If Timer=0 Then
              For i=1 To 2
                Gosub ProcessCPU
                Do Until CLKPulseCount=0
                  Gosub ProcessCPU
                Loop
              Next
              If Inkey=$48 Then
                Do While Inkey=$48
                  SimSpeed=SimSpeed+10
                  If SimSpeed>2048 Then
                    SimSpeed=2048
                  End If
                  Gosub UpdateSimSpeed
                  Delay(50)
                Loop
              End If
              If Inkey=$50 Then
                Do While Inkey=$50
                  SimSpeed=SimSpeed-10
                  If SimSpeed>$FF00 Then
                    SimSpeed=0
                  End If
                  Gosub UpdateSimSpeed
                  Delay(50)
                Loop
              End If
              Timer(SimSpeed)
            End If
            If Inkey='S' Then
              Gosub GetKeyBdShiftStatus
              If Key=8 Then
                Gosub StopSelected
                Goto _Br_Run_Menu_Operation2
              End If
            End If
            If BrkPtFlag=255 Then
              BrkPtFlag = 0
              Gosub StopSelected
              Color(15)
              Gosub ShowTrace
              Goto _Br_Run_Menu_Operation2
            End If
          Else
            If Inkey='C' Then
              Gosub GetKeyBdShiftStatus
              If Key=8 Then
                Gosub ClockPulseSelected
              End If
            End If
            If Inkey='G' Then
              Gosub GetKeyBdShiftStatus
              If Key=8 Then
                Gosub GoSelected
              End If
            End If
            If Inkey='S' Then
              Gosub GetKeyBdShiftStatus
              If Key=8 Then
                Gosub SingleCycleSelected
              End If
            End If
          End If
          If Inkey='R' Then
            Gosub GetKeyBdShiftStatus
            If Key=8 Then
_Br_Reset_Menu_Operation:
              Color Blue,Bright White
              Print At 1,0,"Reset";
              Do While [V0B]=1 Or Key=8
                CHIP16BEGIN
                > GETM R02 R03 V0B
                CHIP16END
                Gosub GetKeyBdShiftStatus
              Loop
              Goto RefreshMainScreen
            End If
          End If
        Loop
      End If
    End If
    Gosub ScrollBar
  Else
    If [V0B]=2 Then
      Gosub RightMouseButton
    End If
  End If
Loop
Goto Main

Sub UpdateBigScrollMemPos
Color Cyan,Bright White
'Erase Scroll Bar Cursor
Print At 56,BigScrollMemPos,CHR($B0);
BigScrollMemPos=CPUMemAdd/$AAA
BigScrollMemPos=BigScrollMemPos+3
Print At 56,BigScrollMemPos,CHR($B2);
Color(15)
Gosub UpdateMemoryLocationData
Delay(20)
End Sub

Sub ProcessCPU
If StateCode=0 Then
  'Fetch
  If CLKPulseCount = 0 Then
    CPUMemAddHIGH = Reg(RegP).BYTE1
    CPU_NLines = 0
  Else
    If CLKPulseCount = 2 Then
      TPAPulse = 1
    Else
      If CLKPulseCount = 3 Then
        MRDPulse = 0
      Else
        If CLKPulseCount = 4 Then
          TPAPulse = 0
        Else
          If CLKPulseCount = 5 Then
            CPUMemAddLOW = Reg(RegP)
            Gosub GetCPUMemAddAndBus
            If BreakPoint=CPUMemAdd Then
              Dim BrkPtFlag As Byte=255
            End If
            RegI = CPUBusValue SHIFT>> 4
            RegN = CPUBusValue And 15
            LongBranchFlag = 0
            If CPUBusValue>=$10 And CPUBusValue<=$2F Or CPUBusValue>=$80 And CPUBusValue<=$BF Or CPUBusValue>=$D0 And CPUBusValue<=$EF Or CPUBusValue=$76 Or CPUBusValue=$7A Or CPUBusValue=$7B Or CPUBusValue=$7E Or CPUBusValue=$F6 Or CPUBusValue=$FE Then
              MemCycleType = 1
            Else
              If CPUBusValue>=$50 And CPUBusValue<=$60 Or CPUBusValue=$73 Or CPUBusValue=$78 Or CPUBusValue=$79 Then
                MemCycleType = 2
              Else
                If CPUBusValue>=0 And CPUBusValue<=$0F Or CPUBusValue>=$30 And CPUBusValue<=$4F Or CPUBusValue>=$70 And CPUBusValue<=$72 Or CPUBusValue>=$F0 And CPUBusValue<=$F2 Or CPUBusValue>=$F8 And CPUBusValue<=$FD Or CPUBusValue=$74 Or CPUBusValue=$75 Or CPUBusValue=$77 Or CPUBusValue=$7C Or CPUBusValue=$7D Or CPUBusValue=$7F Or CPUBusValue=$FF Then
                  MemCycleType = 3
                Else
                  If CPUBusValue>=$C0 And CPUBusValue<=$CF Then
                    MemCycleType = 4
                    LongBranchFlag = 1
                  Else
                    If CPUBusValue>=$69 And CPUBusValue<=$6F Then
                      MemCycleType = 5
                    Else
                     'CPUBusValue>=$61 And CPUBusValue<=$67
                     MemCycleType = 6
                    End If
                  End If
                End If
              End If
            End If
            'Inc RP if not 00 Idle instruction
            If CPUBusValue <> 0 Then
              Reg(RegP)=Reg(RegP)+1
            End If
          Else
            If CLKPulseCount = 13 Then
              TPBPulse = 1
            Else
              If CLKPulseCount = 15 Then
                TPBPulse = 0
                StateCode = 1
              End If
            End If
          End If
        End If
      End If
    End If
  End If
Else
  If StateCode=1 Then
    'Execute
    If ModeControl <> 0 Then
      If CLKPulseCount = 2 Then
        TPAPulse = 1
        If CDP1861IntStartFlag=255 Then
          EFLAG1 = 1
          CDP1861Timing = CDP1861Timing + 1
          If CDP1861Timing = 14 Then
            INTPulse = 0
          End If
          If CDP1861Timing = 29 Then
            INTPulse = 1
            EFLAG1 = 0
            CDP1861IntStartFlag = 0
            CDP1861IntFlag = 255
            CDP1861Timing = 0
            CDP1861Timing2 = 0
          End If
        End If
        If CDP1861IntFlag=255 Then
          If CDP1861Timing2 < 128 Then
            CDP1861Timing = CDP1861Timing + 1
            If CDP1861Timing = 2 Then
              DMAOUTPulse = 0
            End If
            If CDP1861Timing = 3 Or CDP1861Timing = 11 Then
              DMAOUT_INTFlag = 255
              CDP1861Timing2 = CDP1861Timing2 + 1
              If CDP1861Timing = 11 Then
                CDP1861Timing = 0
              End If
            End If
            If CDP1861Timing2 = 124 And CDP1861Timing = 1 Then
              EFLAG1 = 1
            End If
          Else
            EFLAG1 = 0
            CDP1861Timing2 = CDP1861Timing2 + 1
            If CDP1861Timing2 >= 511 Then
              DMAOUT_INTFlag = 0
              CDP1861IntStartFlag = 255
              CDP1861IntFlag = 0
              Dim CDP1861Timing As Byte = 0
              Dim CDP1861Timing2 As Word = 0
              Dim CDP1861Xpos As Byte
              Dim CDP1861Ypos As Byte = 16
              scanline=0
            End If
          End If
        End If
      End If
      If CLKPulseCount = 4 Then
        TPAPulse = 0
      End If
    End If
    If CLKPulseCount = 3 Then
      If MemCycleType = 3 Or MemCycleType = 4 Or MemCycleType = 6 Then
        MRDPulse = 0
      End If
      Gosub GetCPUMemAddAndBus
      If ModeControl = 3 Then
        If RegI = 0 Then
          If RegN = 0 Then
            'IDLE (00-IDL)
            CPUMemAddHIGH = Reg(0).BYTE1
            CPUMemAddLOW = Reg(0)
            Gosub GetCPUMemAddAndBus
          Else
            'Load via N (0N-LDN)
            Gosub GetCPUMemAddAndBusWithRegN
            RegDAcc = CPUBusValue
          End If
          Goto SKIPBR01
        End If
        If RegI = 1 Then
          'Increment Reg N (1N)
          Reg(RegN)=Reg(RegN)+1
          Goto SKIPBR01
        End If
        If RegI = 2 Then
          'Decrement Reg N (2N)
          Reg(RegN)=Reg(RegN)-1
          Goto SKIPBR01
        End If
        If RegI = 3 Then
          'Short branch (3N)
          Gosub GetCPUMemAddAndBusWithRegP
          If RegN = 0 Then
            'Unconditional short branch (30-BR)
            Reg(RegP).BYTE0=CPUBusValue
          Else
            If RegN = 8 Then
              'No short branch or short skip (38-NBR or SKP)
              Reg(RegP)=Reg(RegP)+1
            Else
              If RegN = 2 Then
                'Short branch if D=0 (32-BZ)
                If RegDAcc = 0 Then
                  Reg(RegP).BYTE0=CPUBusValue
                Else
                  Reg(RegP)=Reg(RegP)+1
                End If
              Else
                If RegN = $0A Then
                  'Short branch if D<>0 (3A-BNZ)
                  If RegDAcc <> 0 Then
                    Reg(RegP).BYTE0=CPUBusValue
                  Else
                    Reg(RegP)=Reg(RegP)+1
                  End If
                Else
                  If RegN = 3 Then
                    'Short branch if DF=1 (33-BDF);
                    'If Pos or Zero; If Equal or Greater  (33-BPZ or BGE)
                    If RegDF = 1 Then
                      Reg(RegP).BYTE0=CPUBusValue
                    Else
                      Reg(RegP)=Reg(RegP)+1
                    End If
                  Else
                    If RegN = $0B Then
                      'Short branch if DF=0 (3B-BNF);
                      'If Minus; If Less (3B-BM or BL)
                      If RegDF = 0 Then
                        Reg(RegP).BYTE0=CPUBusValue
                      Else
                        Reg(RegP)=Reg(RegP)+1
                      End If
                    Else
                      If RegN = 1 Then
                        'Short branch if Q=1 (31-BQ)
                        If RegQ = 1 Then
                          Reg(RegP).BYTE0=CPUBusValue
                        Else
                          Reg(RegP)=Reg(RegP)+1
                        End If
                      Else
                        If RegN = 9 Then
                          'Short branch if Q=0 (39-BNQ)
                          If RegQ = 0 Then
                            Reg(RegP).BYTE0=CPUBusValue
                          Else
                            Reg(RegP)=Reg(RegP)+1
                          End If
                        Else
                          If RegN = 4 Then
                            'Short branch if EF1=1 (34-B1)
                            If EFLAG1 = 1 Then
                              Reg(RegP).BYTE0=CPUBusValue
                            Else
                              Reg(RegP)=Reg(RegP)+1
                            End If
                          Else
                            If RegN = $0C Then
                              'Short branch if EF1=0 (34-BN1)
                              If EFLAG1 = 0 Then
                                Reg(RegP).BYTE0=CPUBusValue
                              Else
                                Reg(RegP)=Reg(RegP)+1
                              End If
                            Else
                              If RegN = 5 Then
                                'Short branch if EF2=1 (35-B2)
                                If EFLAG2 = 1 Then
                                  Reg(RegP).BYTE0=CPUBusValue
                                Else
                                  Reg(RegP)=Reg(RegP)+1
                                End If
                              Else
                                If RegN = $0D Then
                                  'Short branch if EF2=0 (3D-BN2)
                                  If EFLAG2 = 0 Then
                                    Reg(RegP).BYTE0=CPUBusValue
                                  Else
                                    Reg(RegP)=Reg(RegP)+1
                                  End If
                                Else
                                  If RegN = 6 Then
                                    'Short branch if EF3=1 (36-B3)
                                    If EFLAG3 = 1 Then
                                      Reg(RegP).BYTE0=CPUBusValue
                                    Else
                                      Reg(RegP)=Reg(RegP)+1
                                    End If
                                  Else
                                    If RegN = $0E Then
                                      'Short branch if EF3=0 (3E-BN3)
                                      If EFLAG3 = 0 Then
                                        Reg(RegP).BYTE0=CPUBusValue
                                      Else
                                        Reg(RegP)=Reg(RegP)+1
                                      End If
                                    Else
                                      If RegN = 7 Then
                                        'Short branch if EF4=1 (37-B4)
                                        If EFLAG4 = 1 Then
                                          Reg(RegP).BYTE0=CPUBusValue
                                        Else
                                          Reg(RegP)=Reg(RegP)+1
                                        End If
                                      Else
                                        'Short branch if EF4=0 (3F-BN4)
                                        If EFLAG4 = 0 Then
                                          Reg(RegP).BYTE0=CPUBusValue
                                        Else
                                          Reg(RegP)=Reg(RegP)+1
                                        End If
                                      End If
                                    End If
                                  End If
                                End If
                              End If
                            End If
                          End If
                        End If
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
          Goto SKIPBR01
        End If
        If RegI = 4 Then
          'Load Advance (4N-LDA)
          Gosub GetCPUMemAddAndBusWithRegN
          RegDAcc = CPUBusValue
          Reg(RegN)=Reg(RegN)+1
          Goto SKIPBR01
        End If
        If RegI = 5 Then
          'Store via N (5N)
          Gosub GetCPUMemAddAndBusWithRegN
          MemoryBytes(CPUMemAdd)=RegDAcc
          CPUBusValue = RegDAcc
          Goto SKIPBR01
        End If
        If RegI = 6 Then
          If RegN = 0 Then
            'Increment Reg X (60)
            Reg(RegX)=Reg(RegX)+1
          Else
            If RegN<8 Then
              Gosub GetCPUMemAddAndBusWithRegX
              If RegN=4 Then
                LEDVal=CPUBusValue
                Gosub UpdateRegisters
              Else
                If RegN=1 Then
                  CDP1861Visible = 0
                  CDP1861IntFlag = 0
                End If
              End If
              Reg(RegX)=Reg(RegX)+1
            Else
              CPUMemAddHIGH = Reg(RegX).BYTE1
              CPUMemAddLOW = Reg(RegX)
              CPUMemAdd=CPUMemAddHIGH * 256
              CPUMemAdd=CPUMemAdd + CPUMemAddLOW
              'Make sure memory address stays within the 16K
              CPUMemAdd=CPUMemAdd And $3FFF
              If RegN=$0C Then
                CPUBusValue=KeyPadVal
              Else
                If RegN=9 Then
                  If CDP1861IntFlag=0 And CDP1861IntStartFlag=0 Then
                    CDP1861IntStartFlag = 255
                    CDP1861Ypos = 16
                    CDP1861Visible = 255
                  End If
                End If
              End If
              MemoryBytes(CPUMemAdd)=CPUBusValue
              RegDAcc=CPUBusValue
            End If
            If RegN=1 Or RegN=9 Then
              CPU_NLines = 1
            Else
              If RegN=2 Or RegN=$0A Then
                CPU_NLines = 2
              Else
                If RegN=3 Or RegN=$0B Then
                  CPU_NLines = 3
                Else
                  If RegN=4 Or RegN=$0C Then
                    CPU_NLines = 4
                  Else
                    If RegN=5 Or RegN=$0D Then
                      CPU_NLines = 5
                    Else
                      If RegN=6 Or RegN=$0E Then
                        CPU_NLines = 6
                      Else
                        'RegN=7 Or RegN=$0F
                        CPU_NLines = 7
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
          Goto SKIPBR01
        End If
        If RegI = 7 Then
          If RegN = 0 Or RegN = 1 Then
            'Return (70-RET) and Disable (71-DIS)
            Gosub GetCPUMemAddAndBusWithRegX
            RegP = CPUBusValue And $0F
            CPUBusValue = CPUBusValue SHIFT>> 4
            Reg(RegX)=Reg(RegX)+1
            If RegN = 0 Then
              RegIE = 1
            Else
              RegIE = 0
            End If
            RegX = CPUBusValue
          Else
            If RegN = 2 Then
              'Load via X and advance (72-LDXA)
               Gosub GetCPUMemAddAndBusWithRegX
               RegDAcc = CPUBusValue
               Reg(RegX)=Reg(RegX)+1
            Else
              If RegN = 3 Then
                'Store via X and Decrement (73-STXD)
                Gosub GetCPUMemAddAndBusWithRegX
                MemoryBytes(CPUMemAdd)=RegDAcc
                CPUBusValue = RegDAcc
                Reg(RegX)=Reg(RegX)-1
              Else
                If RegN = 4 Then
                  'Add with carry (74-ADC)
                  Gosub GetCPUMemAddAndBusWithRegX
Branch74:
                  MathOperVal = CPUBusValue + RegDAcc
                  MathOperVal = MathOperVal + RegDF
                  CPUBusValue = MathOperVal And $FF
                  RegDAcc = CPUBusValue
Branch74B:
                  If MathOperVal > 255 Then
                    RegDF = 1
                  Else
                    RegDF = 0
                  End If
                Else
                  If RegN = 5 Then
                    'Subtract D with borrow(75-SDB)
                    Gosub GetCPUMemAddAndBusWithRegX
Branch75:
                    MathOperVal = CPUBusValue - RegDAcc
Branch75B:
                    Dim NotDF As Byte=RegDF Xor 1
                    MathOperVal = MathOperVal - NotDF
                    CPUBusValue = MathOperVal And $FF
                    RegDAcc=CPUBusValue
Branch75C:
                    If MathOperVal < 0 Then
                      RegDF=0
                    Else
                      RegDF=1
                    End If
                  Else
                    If RegN = 6 Then
                      'Shift right with carry (76-SHRC/RSHR)
                      Dim SaveDF As Byte = RegDF <<SHIFT 7
                      RegDF = RegDAcc And 1
                      RegDAcc = RegDAcc SHIFT>> 1
                      RegDAcc = RegDAcc Or SaveDF
                    Else
                      If RegN = 7 Then
                        'Subtract memory with borrow(77-SMB)
                        Gosub GetCPUMemAddAndBusWithRegX
Branch77:
                        MathOperVal = RegDAcc - CPUBusValue
                        Goto Branch75B
                      Else
                        If RegN = 8 Then
                          'Save (78)
                          Gosub GetCPUMemAddAndBusWithRegX
                          MemoryBytes(CPUMemAdd)=RegT
                          CPUBusValue = RegT
                        Else
                          If RegN = 9 Then
                            'Push X,P to Stack (79-MARK)
                            CPUBusValue = RegX
                            CPUBusValue = CPUBusValue <<SHIFT 4
                            CPUBusValue = CPUBusValue Or RegP
                            RegT = CPUBusValue
                            CPUMemAddHIGH = Reg(2).BYTE1
                            CPUMemAddLOW = Reg(2)
                            MemoryBytes(CPUMemAdd) = CPUBusValue
                            RegX = RegP
                            Reg(2)=Reg(2)-1
                          Else
                            If RegN = $0C Then
                              'Add with carry immediate (7C-ADCI)
                              Gosub GetCPUMemAddAndBusWithRegP
                              Reg(RegP)=Reg(RegP)+1
                              Goto Branch74
                            Else
                              If RegN = $0D Then
                                'Subtract D with borrow immediate (7D-SDBI)
                                Gosub GetCPUMemAddAndBusWithRegP
                                Reg(RegP)=Reg(RegP)+1
                                Goto Branch75
                              Else
                                If RegN = $0E Then
                                  'Shift left with carry; Ring shift left (7E-SHLC or RSHL)
                                  SaveDF = RegDF
                                  If RegDAcc And $80 = 128 Then
                                    RegDF = 1
                                  Else
                                    RegDF = 0
                                  End If
                                  RegDAcc =RegDAcc <<SHIFT 1
                                  RegDAcc =RegDAcc And 255
                                  RegDAcc = RegDAcc Or SaveDF
                                Else
                                  If RegN = $0F Then
                                    'Subtract memory with borrow immediate (7F-SMBI)
                                    Gosub GetCPUMemAddAndBusWithRegP
                                    Reg(RegP)=Reg(RegP)+1
                                    Goto Branch77
                                  Else
                                    If RegN = $0A Then
                                      'Reset Q (7A-REQ)
                                      RegQ = 0
                                    Else
                                      'Set Q (7B-SEQ)
                                      RegQ = 1
                                    End If
                                    Gosub UpdateRegisters
                                  End If
                                End If
                              End If
                            End If
                          End If
                        End If
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
          Goto SKIPBR01
        End If
        If RegI = 8 Then
          'Get low reg N (8N-GLO)
          RegDAcc = Reg(RegN)
          CPUBusValue = RegDAcc
          Goto SKIPBR01
        End If
        If RegI = 9 Then
          'Get high reg N (9N-GHI)
          RegDAcc = Reg(RegN).BYTE1
          CPUBusValue = RegDAcc
          Goto SKIPBR01
        End If
        If RegI = $0A Then
          'Put low reg N (AN-PLO)
          Reg(RegN).BYTE0 = RegDAcc
          CPUBusValue = RegDAcc
          Goto SKIPBR01
        End If
        If RegI = $0B Then
          'Put high reg N (BN-PHI)
          Reg(RegN).BYTE1 = RegDAcc
          CPUBusValue = RegDAcc
          Goto SKIPBR01
        End If
        If RegI = $0C Then
          'Long branch (CN)
          Gosub GetCPUMemAddAndBusWithRegP
          If RegN=0 Then
            'Unconditional long branch (C0-LBR)
            Gosub LongBranchCommon
          Else
            If RegN=8 Then
              'No long branch or long skip (C8-NLBR or LSKP)
              Gosub LongSkipCommon
            Else
              If RegN=4 Then
                'No operation (C4-NOP)
                If LongBranchFlag = 1 Then
                  LongBranchFlag = 2
                Else
                  LongBranchFlag = 3
                End If
              Else
                If RegN=2 Then
                  'Long branch if D=0 (C2-LBZ)
                  If RegDAcc = 0 Then
                    Gosub LongBranchCommon
                  Else
                    Gosub LongSkipCommon
                  End If
                Else
                  If RegN=$0A Then
                    'Long branch if D<>0 (CA-LBNZ)
                    If RegDAcc <> 0 Then
                      Gosub LongBranchCommon
                    Else
                      Gosub LongSkipCommon
                    End If
                  Else
                    If RegN=3 Then
                      'Long branch if DF=1 (C3-LBDF)
                      If RegDF = 1 Then
                        Gosub LongBranchCommon
                      Else
                        Gosub LongSkipCommon
                      End If
                    Else
                      If RegN=$0B Then
                        'Long branch if DF=0 (CB-LBNF)
                        If RegDF = 0 Then
                          Gosub LongBranchCommon
                        Else
                          Gosub LongSkipCommon
                        End If
                      Else
                        If RegN=1 Then
                          'Long branch if Q=1 (C1-LBQ)
                          If RegQ = 1 Then
                            Gosub LongBranchCommon
                          Else
                            Gosub LongSkipCommon
                          End If
                        Else
                          If RegN=9 Then
                            'Long branch if Q=0 (C9-LBNQ)
                            If RegQ = 0 Then
                              Gosub LongBranchCommon
                            Else
                              Gosub LongSkipCommon
                            End If
                          Else
                            If RegN=$0E Then
                              'Long skip if D=0 (CE-LSZ)
                              If RegDAcc = 0 Then
                                Gosub LongSkipCommon
                              End If
                            Else
                              If RegN=6 Then
                                'Long skip if D<>0 (C6-LSNZ)
                                If RegDAcc <> 0 Then
                                  Gosub LongSkipCommon
                                End If
                              Else
                                If RegN=$0F Then
                                  'Long skip if DF=1 (CF-LSDF)
                                  If RegDF = 1 Then
                                    Gosub LongSkipCommon
                                  End If
                                Else
                                  If RegN=7 Then
                                    'Long skip if DF=0 (C7-LSNF)
                                    If RegDF = 0 Then
                                      Gosub LongSkipCommon
                                    End If
                                  Else
                                    If RegN=$0D Then
                                      'Long skip if Q=1 (CD-LSQ)
                                      If RegQ = 1 Then
                                        Gosub LongSkipCommon
                                      End If
                                    Else
                                      If RegN=5 Then
                                        'Long skip if Q=0 (C5-LSNQ)
                                        If RegQ = 0 Then
                                          Gosub LongSkipCommon
                                        End If
                                      Else
                                        'Long skip if IE=1 (CC-LSIE)
                                        If RegIE = 1 Then
                                          Gosub LongSkipCommon
                                        End If
                                      End If
                                    End If
                                  End If
                                End If
                              End If
                            End If
                          End If
                        End If
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
          Goto SKIPBR01
        End If
        If RegI = $0D Then
          'Set P (DN-SEP)
          RegP = RegN
          Gosub GetCPUMemAddAndBusWithRegN
          CPUBusValue = RegN <<SHIFT 4
          CPUBusValue = CPUBusValue Or RegN
          Goto SKIPBR01
        End If
        If RegI = $0E Then
          'Set X (EN-SEX)
          RegX = RegN
          Gosub GetCPUMemAddAndBusWithRegN
          CPUBusValue = RegN <<SHIFT 4
          CPUBusValue = CPUBusValue Or RegN
          Goto SKIPBR01
        End If
        If RegI = $0F Then
          If RegN=0 Then
            'Load via X (F0-LDX)
            Gosub GetCPUMemAddAndBusWithRegX
            RegDAcc = CPUBusValue
          Else
            If RegN=1 Then
              'Or (F1-OR)
              Gosub GetCPUMemAddAndBusWithRegX
              CPUBusValue = CPUBusValue Or RegDAcc
              RegDAcc = CPUBusValue
            Else
              If RegN=2 Then
                'And (F2-AND)
                Gosub GetCPUMemAddAndBusWithRegX
                CPUBusValue = CPUBusValue And RegDAcc
                RegDAcc = CPUBusValue
              Else
                If RegN=3 Then
                  'Exclusive Or (F3-XOR)
                  Gosub GetCPUMemAddAndBusWithRegX
                  CPUBusValue = CPUBusValue Xor RegDAcc
                  RegDAcc = CPUBusValue
                Else
                  If RegN=4 Then
                    'Add (F4-ADD)
                    Gosub GetCPUMemAddAndBusWithRegX
                    MathOperVal = CPUBusValue + RegDAcc
                    RegDAcc = MathOperVal And 255
                    Goto Branch74B
                  Else
                    If RegN=5 Then
                      'Subtract D (F5-SD)
                      Gosub GetCPUMemAddAndBusWithRegX
                      MathOperVal = CPUBusValue - RegDAcc
                      RegDAcc = MathOperVal And 255
                      Goto Branch75C
                    Else
                      If RegN=6 Then
                        'Shift right (F6-SHR)
                        RegDF = RegDAcc And 1
                        RegDAcc = RegDAcc SHIFT>> 1
                      Else
                        If RegN=7 Then
                          'Subtract memory (F7-SM)
                          Gosub GetCPUMemAddAndBusWithRegX
                          MathOperVal = RegDAcc - CPUBusValue
                          RegDAcc = MathOperVal And 255
                          Goto Branch75C
                        Else
                          If RegN=8 Then
                            'Load immediate (F8-LDI)
                            Gosub GetCPUMemAddAndBusWithRegP
                            RegDAcc = CPUBusValue
                            Reg(RegP)=Reg(RegP)+1
                          Else
                            If RegN=9 Then
                              'Or immediate (F9-ORI)
                              Gosub GetCPUMemAddAndBusWithRegP
                              RegDAcc = CPUBusValue Or RegDAcc
                              Reg(RegP)=Reg(RegP)+1
                            Else
                              If RegN=$0A Then
                                'And immediate (FA-ANI)
                                Gosub GetCPUMemAddAndBusWithRegP
                                RegDAcc = CPUBusValue And RegDAcc
                                Reg(RegP)=Reg(RegP)+1
                              Else
                                If RegN=$0B Then
                                  'Exclusive Or immediate (FB-XRI)
                                  Gosub GetCPUMemAddAndBusWithRegP
                                  RegDAcc = CPUBusValue Xor RegDAcc
                                  Reg(RegP)=Reg(RegP)+1
                                Else
                                  If RegN=$0C Then
                                    'Add immediate (FC-ADI)
                                    Gosub GetCPUMemAddAndBusWithRegP
                                    MathOperVal = CPUBusValue + RegDAcc
                                    RegDAcc = MathOperVal And 255
                                    Reg(RegP)=Reg(RegP)+1
                                    Goto Branch74B
                                  Else
                                    If RegN=$0D Then
                                      'Subtract D immediate (FD-SDI)
                                      Gosub GetCPUMemAddAndBusWithRegP
                                      MathOperVal = CPUBusValue - RegDAcc
                                      RegDAcc = MathOperVal And 255
                                      Reg(RegP)=Reg(RegP)+1
                                      Goto Branch75C
                                    Else
                                      If RegN=$0E Then
                                        'Shift left (FE-SHL)
                                        If RegDAcc And $80 = 128 Then
                                          RegDF = 1
                                        Else
                                          RegDF = 0
                                        End If
                                        RegDAcc = RegDAcc <<SHIFT 1
                                      Else
                                        'Subtract memory immediate (FF-SMI)
                                        Gosub GetCPUMemAddAndBusWithRegP
                                        MathOperVal = RegDAcc - CPUBusValue
                                        RegDAcc = MathOperVal And 255
                                        Reg(RegP)=Reg(RegP)+1
                                        Goto Branch75C
                                      End If
                                    End If
                                  End If
                                End If
                              End If
                            End If
                          End If
                        End If
                      End If
                    End If
                  End If
                End If
              End If
            End If
          End If
        End If
      End If
    End If
SKIPBR01:
    If MemCycleType = 2 Or MemCycleType = 5 And CLKPulseCount = 10 Then
      MWRPulse = 0
    Else
      If CLKPulseCount = 13 Then
        TPBPulse = 1
      Else
        If CLKPulseCount = 15 Then
          TPBPulse = 0
          'Check if DMA IN occured 1st, then check for DMA OUT
          'If not, then check if Interrupt occured and IE flag is set
          If DMAINPulse = 0 Then
            DMAIN_INTFlag = 255
            StateCode = 2
          Else
            If DMAOUTPulse = 0 Then
              DMAOUT_INTFlag = 255
              StateCode = 2
            Else
              If INTPulse = 0 And RegIE = 1 Then
                StateCode = 3
              Else
                If RegI = 0 And RegN = 0 Or LongBranchFlag = 2 Then
                  StateCode = 1
                Else
                  StateCode = 0
                End If
              End If
            End If
          End If
          If MemCycleType = 2 Or MemCycleType = 5 Then
            MWRPulse = 1
          End If
        End If
      End If
    End If
  Else
    If StateCode=2 Then
      'DMA IN or DMA OUT
      If DMAIN_INTFlag = 255 Then
        If CLKPulseCount = 10 Then
          MWRPulse = 0
        End If
      End If
      If DMAOUT_INTFlag = 255 Then
        If CLKPulseCount = 3 Then
          MRDPulse = 0
        End If
        If CLKPulseCount = 13 Then
          CPUMemAddHIGH = Reg(0).BYTE1
          CPUMemAddLOW = Reg(0)
          Gosub GetCPUMemAddAndBus
          If CDP1861Visible = 255 Then
            CDP1861Xpos = CPUMemAddLOW MODULO 8
            CDP1861Xpos = CDP1861Xpos * 16
            i=scanline/4
            PatternYpos=CDP1861Ypos+i
            Gosub DisplayByteAtMemLoc
            If CDP1861Xpos=112 Then
              scanline=scanline+1
              If scanline=129 Then
                scanline=0
              End If
            End If
          End If
        End If
      End If
      If CLKPulseCount = 2 Then
        TPAPulse = 1
        If CDP1861IntFlag=255 Then
          CDP1861Timing = CDP1861Timing + 1
          If CDP1861Timing > 9 Then
            DMAOUTPulse = 1
          End If
        End If
      Else
        If CLKPulseCount = 4 Then
          TPAPulse = 0
        Else
          If CLKPulseCount = 13 Then
            TPBPulse = 1
            'Check if DMA IN occured first before DMA OUT
            temp2 = 0
            If DMAINPulse = 0 Then
              temp1 = 1
            Else
              temp1 = 0
              If DMAOUTPulse = 0 Then
                DMAOUT_INTFlag = 255
                temp2 = 1
              End If
            End If
          Else
            If CLKPulseCount = 14 Then
              MWRPulse = 1
              CPUMemAddHIGH = Reg(0).BYTE1
              CPUMemAddLOW = Reg(0)
              Gosub GetCPUMemAddAndBus
              If DMAIN_INTFlag = 255 Then
                'For now since there is no data from an I/O device
                'DMA IN will read a FFh value from the DataBus
                CPUBusValue=255
                MemoryBytes(CPUMemAdd)=255
              End If
              Reg(0)=Reg(0)+1
            Else
              If CLKPulseCount = 15 Then
                TPBPulse = 0
                'If no DMA IN and DMA OUT, then OK to change statecode
                If DMAIN_INTFlag = 0 And DMAOUT_INTFlag = 0 Then
                  If ModeControl <> 0 Then
                    StateCode = 0
                  Else
                    StateCode = 1
                  End If
                Else
                  If DMAOUTPulse = 1 And CDP1861Timing = 10 Then
                    StateCode = 0
                  End If
                End If
                If temp1=0 Then
                  DMAIN_INTFlag = 0
                End If
                If temp2=0 Then
                  DMAOUT_INTFlag = 0
                End If
              End If
            End If
          End If
        End If
      End If
    Else
      'Interrupt
      RegT = RegX <<SHIFT 4
      RegT = RegT Or RegP
      RegP = 1
      RegX = 2
      RegIE = 0
      MemCycleType = 1
      StateCode = 0
    End If
  End If
End If
If SimSpeed<>0 Then
  Color(15)
  If CLKPulseCount = 15 Then
    Gosub ShowTrace
  End If
  Gosub UpdateRegisters
End If
CLKPulseCount=CLKPulseCount+1
If CLKPulseCount = 16 Then
  CLKPulseCount = 0
  MRDPulse = 1
End If
End Sub

Sub ShowTrace
Gosub UpdateMemoryLocationData
Color Red,Yellow
TempWord=CPUMemAdd MODULO 16
i=TempWord*3
[V03]=8+i
[V00]=[V03]
[V01]=3
CHIP16BEGIN
> LCAT V00 V01
CHIP16END
temp1=[V00]
Print At [V03],3,CHR(temp1);
[V00]=[V03]
[V01]=3
CHIP16BEGIN
> LCAT V00 V01
CHIP16END
temp1=[V00]
Print At [V03],3,CHR(temp1);
End Sub

Sub UpdateRegisters
Color Blue,Yellow
[V03]=65
For i=0 To 7
  Print At [V03],3,HEX(Reg(i));
  [V03]=[V03]+4
Next
[V03]=65
For i=8 To 15
  Print At [V03],4,HEX(Reg(i));
  [V03]=[V03]+4
Next
Print At 121,2,HEX(BreakPoint);
NibbleStr=HEX(RegI)
Print At 64,6,RIGHT(NibbleStr,1);
NibbleStr=HEX(RegN)
Print At 70,[V04],RIGHT(NibbleStr,1);
NibbleStr=HEX(RegP)
Print At 76,[V04],RIGHT(NibbleStr,1);
NibbleStr=HEX(RegX)
Print At 82,[V04],RIGHT(NibbleStr,1);
Print At 88,[V04],HEX(RegT);
Print At 95,[V04],HEX(RegDAcc);
NibbleStr=CSTR(RegDF)
Print At 103,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(RegQ)
Print At 109,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(RegIE)
Print At 116,[V04],RIGHT(NibbleStr,1);
Print At 123,[V04],HEX(KeyPadVal);
Print At 65,8,HEX(CPUBusValue);
Print At 72,[V04],HEX(CPUMemAddHIGH);HEX(CPUMemAddLOW);
NibbleStr=HEX(StateCode)
Print At 81,8,RIGHT(NibbleStr,1);
NibbleStr=HEX(CLKPulseCount)
Print At 88,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(DMAINPulse)
Print At 97,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(DMAOUTPulse)
Print At 107,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(INTPulse)
Print At 114,[V04],RIGHT(NibbleStr,1);
Print At 121,[V04],HEX(LEDVal);
NibbleStr=CSTR(TPAPulse)
Print At 66,10,RIGHT(NibbleStr,1);
NibbleStr=CSTR(TPBPulse)
Print At 73,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(MRDPulse)
Print At 80,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(MWRPulse)
Print At 87,[V04],RIGHT(NibbleStr,1);
NibbleStr=HEX(CPU_NLines)
Print At 97,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(EFLAG1)
Print At 104,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(EFLAG2)
Print At 111,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(EFLAG3)
Print At 118,[V04],RIGHT(NibbleStr,1);
NibbleStr=CSTR(EFLAG4)
Print At 125,[V04],RIGHT(NibbleStr,1);
End Sub

Sub GetCPUMemAddAndBus
CPUMemAdd=CPUMemAddHIGH * 256
CPUMemAdd=CPUMemAdd + CPUMemAddLOW
CPUMemAdd=CPUMemAdd And $3FFF
CPUBusValue = MemoryBytes(CPUMemAdd)
End Sub

Sub GetCPUMemAddAndBusWithRegN
CPUMemAddHIGH = Reg(RegN).BYTE1
CPUMemAddLOW = Reg(RegN)
Gosub GetCPUMemAddAndBus
End Sub

Sub GetCPUMemAddAndBusWithRegP
CPUMemAddHIGH = Reg(RegP).BYTE1
CPUMemAddLOW = Reg(RegP)
Gosub GetCPUMemAddAndBus
End Sub

Sub GetCPUMemAddAndBusWithRegX
CPUMemAddHIGH = Reg(RegX).BYTE1
CPUMemAddLOW = Reg(RegX)
Gosub GetCPUMemAddAndBus
End Sub

Sub GetCharAndAtribute
Dim [V00] As Byte=mouseX
Dim [V01] As Byte=mouseY
CHIP16BEGIN
> LCAT V00 V01
CHIP16END
Dim SaveChar As Byte=[V00]
Dim SaveAttribute As Byte=[V01]
'Color(10)
'Print At 62,2,HEX(SaveChar)," ",HEX(SaveAttribute);
'Print At 72,[V04],HEX(mouseX),"(",mouseX,") ",HEX(mouseY),"(",mouseY,")    ";
Color(15)
End Sub

Sub GetMouse1
CHIP16BEGIN
> GETM R02 R03 V0B   ;get x-y and button
> SHIF R02 > #3      ;x/8
> SHIF R03 > #3      ;y/8
CHIP16END
Dim mouseX As Byte=[R02]
Dim mouseY As Byte=[R03]
End Sub

Sub GetMouse2
  Gosub GetMouse1
  If SavemouseX<>mouseX Or SavemouseY<>mouseY Then
    'Restore original character at previous mouse X-Y
    Color(SaveAttribute)
    Print At SavemouseX,SavemouseY,CHR(SaveChar);
    Gosub GetCharAndAtribute
    Print At mouseX,mouseY,CHR($DB);
  End If
  SavemouseX=[R02]
  SavemouseY=[R03]
End Sub

Sub DrawMenuBar
[V03]=0
[V04]=0
Color Cyan,Black
Dim i As Byte
For i=1 To 128
  Print CHR(32);
Next
Color Cyan,Red
Print At 1,0,"F";
Color Cyan,Black
Print "ile";
Color Cyan,Red
Print At 7,[V04],"R";
Color Cyan,Black
Print "un";
Color Green,Yellow
Print At 56,[V04],CHR($B3),LEFT(FileName,26),CHR($B3);
Color(15)
End Sub

Sub DrawBox
Dim [V03] As Byte=TLCx
Dim [V04] As Byte=TLCy
'Draw top horizontal line and title
Print MID(BoxChars,1,1);MID(BoxChars,5,1);BoxTitle;
Dim temp1 As SByte=BRCx-TLCx
Dim temp2 As SByte=LEN(BoxTitle)
temp1=temp1-temp2
temp1=temp1-2
For i=1 To temp1
  Print MID(BoxChars,5,1);
Next
Print MID(BoxChars,2,1);
'Draw right vertical line
temp1=BRCy-TLCy
temp1=temp1-1
For i=1 To temp1
  [V04]=[V04]+1
  Print At BRCx,[V04],MID(BoxChars,6,1);
Next
Print At BRCx,BRCy,MID(BoxChars,3,1);
'Draw left vertical line
[V04]=TLCy
For i=1 To temp1
  [V04]=[V04]+1
  Print At TLCx,[V04],MID(BoxChars,6,1);
Next
Print At TLCx,BRCy,MID(BoxChars,4,1);
'Draw bottom horizontal line
temp2=BRCx-TLCx
temp2=temp2-1
For i=1 To temp2
  Print MID(BoxChars,5,1);
Next
End Sub

Sub DrawMemoryLocationBox
Dim TLCx As Byte=0
Dim TLCy As Byte=1
Dim BRCx As Byte=57
Dim BRCy As Byte=11
Dim BoxTitle As String(30)="Memory Locations"
Gosub DrawBox
Print At 8,2,"00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F";
Gosub UpdateMemoryLocationData
'Draw single vertical line
[V04]=1
For i=1 To 9
  [V04]=[V04]+1
  Print At 55,[V04],CHR($B3);
Next
Print At 55,1,CHR($D1);
Print At 55,11,CHR($CF);
'Draw vertical scroll bar
Color Cyan,Bright White
Print At 56,2,CHR($18);
For i=1 To 7
  [V04]=[V04]+1
  Print At 56,[V04],CHR($B0);
Next
Print At 56,BigScrollMemPos,CHR($B2);
Print At 56,10,CHR($19);
End Sub

Sub UpdateMemoryLocationData
Dim SaveCPUMemAdd As Word
Dim SaveCPUMemAdd2 As Word
TempWord=CPUMemAdd MODULO 16
SaveCPUMemAdd=CPUMemAdd-TempWord
SaveCPUMemAdd2=SaveCPUMemAdd
[V04]=3
For i=1 To 8
  Print At 1,[V04]," ",HEX(SaveCPUMemAdd );" ";
  Color Cyan,Bright White
  TempWord=SaveCPUMemAdd +15
  Dim iw As Word
  For iw=SaveCPUMemAdd To TempWord
    Print " ";HEX(MemoryBytes(iw));
  Next
  Color(15)
  Print
  SaveCPUMemAdd =SaveCPUMemAdd +16
Next
End Sub

Sub GetKeyBdShiftStatus
  'Check to see if ALT key is pressed
  Call _KEYSHIFT
  Key=Peek(4)
  Key=Key And 8
End Sub

Sub Get1802File
'Get 1802 program
fOpen FileName For Input As #1
DefMemPtr(ML2)=@_FHANDLE_1
DefMemPtr(ML3)=@_FOPENMODE_1
Dim fOpenError As Byte
Dim fErrorNumber As Word
fOpenError = Peek(3)
If fOpenError = $EE Then
  Color Red,Yellow
  TLCx=14
  TLCy=6
  BRCx=44
  BRCy=10
  BoxTitle="File I/O Error!"
  BoxChars=CHR($DA) & CHR($BF) & CHR($D9) & CHR($C0) & CHR($C4) & CHR($B3)
  Gosub DrawBox
  Print At 15,7,"Error opening specified file!";
  fErrorNumber = Peek(2)
  Print At 15,8,"Error code = ",HEX(fErrorNumber),STRDUP(23," ");
  Print At 15,9,"Press any key to continue... ";
  Key=Inkey
  Goto Get1802File_Exit
End If
'Get End Of File (EOF)
DefMemPtr(ML2)=@_MOVEMODE
DefMemPtr(ML3)=@_MOVEPTRHIOFFSET
'Relative offset move from the end of file
Poke(2),0,2
fMovePtr #1,0
Dim EOF As DWord
Dim LOC As DWord=0
EOF=Peek(3)
'Swap MSW and LSW of EOF
SWAP EOF
'Move pointer back to beginning of file
Poke(2),0,0
fMovePtr #1,0
Dim maxProgBytes As Word=0
Do While LOC < EOF And maxProgBytes<16384
  'Continue reading all data until reach EOF
  fRead #1,1,MemoryBytes(maxProgBytes)
  maxProgBytes=maxProgBytes+1
  'Get file pointer location
  'Relative offset move from current location
  Poke(2),0,1
  fMovePtr #1,0
  DefMemPtr(ML3)=@_MOVEPTRHIOFFSET
  LOC=Peek(3)
  'Swap MSW and LSW of LOC
  SWAP LOC
Loop
Get1802File_Exit:
fClose #1
End Sub

Sub ASCtoBIN
If BinaryVal>$40 Then
  BinaryVal=BinaryVal-7
End If
BinaryVal=BinaryVal-48
End Sub

Sub ScrollBar
If mouseX=56 Then
  If mouseY=2 Then
    'Up Scroll Arrow
    CPUMemAdd=CPUMemAdd-16
    If CPUMemAdd>$FF00 Then
      CPUMemAdd=0
    End If
  End If
  If mouseY=10 Then
    'Up Scroll Arrow
    CPUMemAdd=CPUMemAdd+16
    If CPUMemAdd>$3F80 Then
      CPUMemAdd=$3F80
    End If
  End If
  Gosub UpdateBigScrollMemPos
  If mouseY>2 And mouseY<10 Then
    'Big Scroll Value
    If mouseY<>BigScrollMemPos Then
      If mouseY<BigScrollMemPos Then
        temp1=1
      Else
        temp1=2
      End If
      Do While [V0B]=1 And mouseX=56 And mouseY>2 And mouseY<10
        If temp1=1 Then
          CPUMemAdd=CPUMemAdd-128
          If CPUMemAdd>$FF00 Then
            CPUMemAdd=0
          End If
        Else
          CPUMemAdd=CPUMemAdd+128
          If CPUMemAdd>$3F80 Then
            CPUMemAdd=$3F80
          End If
        End If
        Gosub UpdateBigScrollMemPos
        Color(15)
        Gosub UpdateMemoryLocationData
        Gosub GetMouse1
        Delay(200)
      Loop
    Else
      Do While [V0B]=1 And mouseX=56 And mouseY>2 And mouseY<10
        Color Cyan,Bright White
        If SavemouseY=mouseY Then
          Print At 56,mouseY,CHR($DB);
        Else
          Print At 56,SavemouseY,CHR($B0);
        End If
        temp2=mouseY-3
        CPUMemAdd=temp2*$AAA
        CPUMemAdd=CPUMemAdd And $FFF0
        If CPUMemAdd>$3F80 Then
          CPUMemAdd=$3F80
        End If
        Color(15)
        Gosub UpdateMemoryLocationData
        SavemouseY=mouseY
        Gosub GetMouse1
        Delay(200)
      Loop
      BigScrollMemPos=mouseY
      If BigScrollMemPos<3 Then
        BigScrollMemPos=3
      End If
      If BigScrollMemPos>9 Then
        BigScrollMemPos=9
      End If
    End If
    Color Cyan,Bright White
    [V04]=2
    For i=1 To 7
      [V04]=[V04]+1
      Print At 56,[V04],CHR($B0);
    Next
    Print At 56,BigScrollMemPos,CHR($B2);
  End If
  Delay(200)
End If
End Sub

Sub ClockPulseSelected
Color Blue,Bright White
Print At 21,0,"ClockPulse";
Do While [V0B]=1
  CHIP16BEGIN
  > GETM R02 R03 V0B
  CHIP16END
Loop
Do While Inkey='C'
Loop
Color Cyan,Red
Print At 21,[V04],"C";
Color Cyan,Black
Print "lockPulse";
Gosub ProcessCPU
End Sub

Sub SingleCycleSelected
Color Blue,Bright White
Print At 8,0,"SingleCycle";
Do While [V0B]=1
  CHIP16BEGIN
  > GETM R02 R03 V0B
  CHIP16END
Loop
Do While Inkey='S'
Loop
Color Cyan,Red
Print At 8,[V04],"S";
Color Cyan,Black
Print "ingleCycle";
Gosub ProcessCPU
Do Until CLKPulseCount=0
  Gosub ProcessCPU
Loop
End Sub

Sub GoSelected
Color Blue,Bright White
Print At 33,0,"Go";
Do While [V0B]=1
  CHIP16BEGIN
  > GETM R02 R03 V0B
  CHIP16END
Loop
Do While Inkey='G'
Loop
Color Cyan,Black
Print At 9,0,"top  SimSpeed=";SimSpeed;STRDUP(11," ");
Operation=12
If mouseY=0 Then
  Gosub GetCharAndAtribute
End If
End Sub

Sub StopSelected
Color Blue,Bright White
Print At 8,0,"Stop";
Do While [V0B]=1 Or Key=8
  CHIP16BEGIN
  > GETM R02 R03 V0B
  CHIP16END
  Gosub GetKeyBdShiftStatus
Loop
If SimSpeed=0 Then
  'Need this or else won't see updates
  SimSpeed=1
End If
End Sub

Sub LongBranchCommon
  If LongBranchFlag = 1 Then
    Dim LongBrHigh As Byte = CPUBusValue
    Reg(RegP)=Reg(RegP)+1
    LongBranchFlag = 2
  Else
    Reg(RegP).BYTE1=LongBrHigh
    Reg(RegP).BYTE0=CPUBusValue
    LongBranchFlag = 3
  End If
End Sub

Sub LongSkipCommon
  If LongBranchFlag = 1 Then
    Reg(RegP)=Reg(RegP)+2
    LongBranchFlag = 2
  Else
    LongBranchFlag = 3
  End If
End Sub

Sub UpdateSimSpeed
Color Cyan,Black
Print At 23,0,SimSpeed;"    ";
End Sub

Sub CommonRoutineEditByte
i=1
Key=0
Do Until Key=13
  Key=Inkey
  If Key>=$61 And Key<=$66 Then
    Key=Key And $4F
  End If
  If Key>=$30 And Key<=$39 Or Key>=$41 And Key<=$46 Or Key=$4B Or Key=$4D Then
    If i=1 Then
      i=2
      Color Red,Yellow
      If Key=$4B Or Key=$4D Then
        Print At temp1,mouseY,CHR(SaveChar1);
      Else
        Print At temp1,mouseY,CHR(Key);
        SaveChar1=Key
        Dim BinaryVal As Byte=Key
        Gosub ASCtoBIN
        BinaryVal=BinaryVal <<SHIFT 4
        NewMemVal=NewMemVal And 15
      End If
      Color Red,Yellow,Blink
      Print At temp2,mouseY,CHR(SaveChar);
    Else
      i=1
      Color Red,Yellow
      If Key=$4B Or Key=$4D Then
        Print At temp2,mouseY,CHR(SaveChar);
      Else
        Print At temp2,mouseY,CHR(Key);
        SaveChar=Key
        BinaryVal=Key
        Gosub ASCtoBIN
        NewMemVal=NewMemVal And $F0
      End If
      Color Red,Yellow,Blink
      Print At temp1,mouseY,CHR(SaveChar1);
    End If
    NewMemVal=NewMemVal Or BinaryVal
  End If
Loop
End Sub

Sub RightMouseButton
If mouseX>61 And mouseX<125 And mouseY>2 And mouseY<5 Then
  'Edit scratchpad registers
  temp1=mouseX / 8
  temp2=mouseX MODULO 8
  If temp2<>5 Then
    temp1=temp1-7
    If temp2<5 Then
      temp1=temp1-1
    End If
    If mouseY=4 Then
      temp1=temp1+8
    End If
    Dim EditRegPtr As Byte=temp1
    'Restore original character at previous mouse X-Y
    Color(SaveAttribute)
    Print At SavemouseX,SavemouseY,CHR(SaveChar);
    If temp2>5 Then
      i=temp2-8
    Else
      i=temp2
    End If
    i=mouseX-i
    temp1=i+1
    Dim HiLoPtr As Byte=1
    If temp2>0 And temp2<5 Then
      'When HiLoPtr=1 --> R(N).1
      'When HiLoPtr=0 --> R(N).0
      If temp2>2 Then
        temp1=i+3
        HiLoPtr=0
      End If
    End If
    temp2=temp1+1
    Gosub RestoreOriginalChar
    'Will use same NewMemVal variable as when editing memory
    If HiLoPtr=1 Then
      NewMemVal=Reg(EditRegPtr).BYTE1
    Else
      NewMemVal=Reg(EditRegPtr)
    End If
    Gosub CommonRoutineEditByte
    If HiLoPtr=1 Then
      Reg(EditRegPtr).BYTE1=NewMemVal
    Else
      Reg(EditRegPtr).BYTE0=NewMemVal
    End If
    Gosub UpdateRegisters
  End If
Else
  If mouseX>7 And mouseX<55 And mouseY>2 And mouseY<11 Then
    'Edit Memory
    temp1=mouseX / 3
    temp2=mouseX MODULO 3
    If temp2<>1 Then
      If temp2=0 Then
        temp1=temp1-3
      Else
        temp1=temp1-2
      End If
      Dim temp3 As Byte=mouseY-3
      Dim memloc As Word
      memloc=16*temp3
      memloc=memloc+temp1
      memloc=memloc+SaveCPUMemAdd2
      If temp2=2 Then
        temp1=mouseX
        temp2=mouseX+1
      Else
        temp2=mouseX
        temp1=mouseX-1
      End If
      Gosub RestoreOriginalChar
      Dim NewMemVal As Byte=MemoryBytes(memloc)
      Gosub CommonRoutineEditByte
      MemoryBytes(memloc)=NewMemVal
      Color(15)
      Gosub DrawMemoryLocationBox
    End If
  Else
    If mouseX>94 And mouseX<97 And mouseY=6 Then
      'Edit RegDAcc
      If mouseX=95 Then
        temp1=mouseX
        temp2=mouseX+1
      Else
        temp2=mouseX
        temp1=mouseX-1
      End If
      Gosub RestoreOriginalChar
      NewMemVal=RegDAcc
      Gosub CommonRoutineEditByte
      RegDAcc=NewMemVal
      Gosub UpdateRegisters
    Else
      If mouseX>122 And mouseX<125 And mouseY=6 Then
        'Edit KeyPadVal
        If mouseX=123 Then
          temp1=mouseX
          temp2=mouseX+1
        Else
          temp2=mouseX
          temp1=mouseX-1
        End If
        Gosub RestoreOriginalChar
        NewMemVal=KeyPadVal
        Gosub CommonRoutineEditByte
        KeyPadVal=NewMemVal
        Gosub UpdateRegisters
      Else
        If mouseX=81 And mouseY=8 Then
          'Toggle StateCode
          'Restore original character at previous mouse X-Y
          Color(SaveAttribute)
          Print At SavemouseX,SavemouseY,CHR(SaveChar);
          Gosub GetCharAndAtribute
          Print At mouseX,mouseY,CHR(SaveChar);
           If StateCode=0 Then
            StateCode=1
            SaveChar=$31
          Else
            StateCode=0
            SaveChar=$30
          End If
          Do While [V0B]=2
            CHIP16BEGIN
            > GETM R02 R03 V0B
            CHIP16END
          Loop
          Gosub UpdateRegisters
        Else
          'Edit BreakPoint
          If mouseX>120 And mouseX<125 And mouseY=2 Then
            'Edit KeyPadVal
            If mouseX=121 Then
              temp1=mouseX
              temp2=mouseX+1
              temp3=mouseX+2
              Dim temp4 As Byte=mouseX+3
            Else
              If mouseX=122 Then
                temp1=mouseX-1
                temp2=mouseX
                temp3=mouseX+1
                temp4=mouseX+2
              Else
                If mouseX=123 Then
                  temp1=mouseX-2
                  temp2=mouseX-1
                  temp3=mouseX
                  temp4=mouseX+1
                Else
                  temp1=mouseX-3
                  temp2=mouseX-2
                  temp3=mouseX-1
                  temp4=mouseX
                End If
              End If
            End If
            'Restore original character at previous mouse X-Y
            Color(SaveAttribute)
            Print At SavemouseX,SavemouseY,CHR(SaveChar);
            mouseX=temp1
            Gosub GetCharAndAtribute
            SaveChar1=SaveChar
            Color Red,Yellow,Blink
            Print At temp1,mouseY,CHR(SaveChar);
            mouseX=temp2
            Gosub GetCharAndAtribute
            Dim SaveChar2 As Byte=SaveChar
            Color Red,Yellow
            Print At temp2,mouseY,CHR(SaveChar);
            mouseX=temp3
            Gosub GetCharAndAtribute
            Dim SaveChar3 As Byte=SaveChar
            Color Red,Yellow
            Print At temp3,mouseY,CHR(SaveChar);
            mouseX=temp4
            Gosub GetCharAndAtribute
            Color Red,Yellow
            Print At temp4,mouseY,CHR(SaveChar);
            TempWord=BreakPoint
            i=1
            Key=0
            Do Until Key=13
              Key=Inkey
              If Key>=$61 And Key<=$66 Then
                Key=Key And $4F
              End If
              If Key>=$30 And Key<=$39 Or Key>=$41 And Key<=$46 Or Key=$4B Or Key=$4D Then
                If i=1 Then
                  Gosub Inci
                  Color Red,Yellow
                  If Key=$4B Or Key=$4D Then
                    Print At temp1,mouseY,CHR(SaveChar1);
                  Else
                    Print At temp1,mouseY,CHR(Key);
                    SaveChar1=Key
                    BinaryVal=Key
                    Gosub ASCtoBIN
                    Dim TempWord2 As Word=BinaryVal <<SHIFT 12
                    TempWord=TempWord And $FFF
                  End If
                  Color Red,Yellow,Blink
                  If Key=$4B Then
                    Print At temp4,mouseY,CHR(SaveChar);
                    i=4
                  Else
                    Print At temp2,mouseY,CHR(SaveChar2);
                  End If
                Else
                  If i=2 Then
                    Gosub Inci
                    Color Red,Yellow
                    If Key=$4B Or Key=$4D Then
                      Print At temp2,mouseY,CHR(SaveChar2);
                    Else
                      Print At temp2,mouseY,CHR(Key);
                      SaveChar2=Key
                      BinaryVal=Key
                      Gosub ASCtoBIN
                      TempWord2=BinaryVal <<SHIFT 8
                      TempWord=TempWord And $F0FF
                    End If
                    Color Red,Yellow,Blink
                    If Key=$4B Then
                      Print At temp1,mouseY,CHR(SaveChar1);
                      i=1
                    Else
                      Print At temp3,mouseY,CHR(SaveChar3);
                    End If
                  Else
                    If i=3 Then
                      Gosub Inci
                      Color Red,Yellow
                      If Key=$4B Or Key=$4D Then
                        Print At temp3,mouseY,CHR(SaveChar3);
                      Else
                        Print At temp3,mouseY,CHR(Key);
                        SaveChar3=Key
                        BinaryVal=Key
                        Gosub ASCtoBIN
                        TempWord2=BinaryVal <<SHIFT 4
                        TempWord=TempWord And $FF0F
                      End If
                      Color Red,Yellow,Blink
                      If Key=$4B Then
                        Print At temp2,mouseY,CHR(SaveChar2);
                        i=2
                      Else
                        Print At temp4,mouseY,CHR(SaveChar);
                      End If
                    Else
                      Gosub Inci
                      Color Red,Yellow
                      If Key=$4B Or Key=$4D Then
                        Print At temp4,mouseY,CHR(SaveChar);
                      Else
                        Print At temp4,mouseY,CHR(Key);
                        SaveChar=Key
                        BinaryVal=Key
                        Gosub ASCtoBIN
                        TempWord2=BinaryVal
                        TempWord=TempWord And $FFF0
                      End If
                      Color Red,Yellow,Blink
                      If Key=$4B Then
                        Print At temp3,mouseY,CHR(SaveChar3);
                        i=3
                      Else
                        Print At temp1,mouseY,CHR(SaveChar1);
                      End If
                    End If
                  End If
                End If
                TempWord=TempWord Or TempWord2
              End If
            Loop
            BreakPoint=TempWord
            Gosub UpdateRegisters
          End If
        End If
      End If
    End If
  End If
End If
SavemouseX=mouseX
SavemouseY=mouseY
End Sub

Sub Inci
i=i+1
If i=5 Then
  i=1
End If
End Sub

Sub RestoreOriginalChar
'Restore original character at previous mouse X-Y
Color(SaveAttribute)
Print At SavemouseX,SavemouseY,CHR(SaveChar);
mouseX=temp1
Gosub GetCharAndAtribute
Dim SaveChar1 As Byte=SaveChar
Color Red,Yellow,Blink
Print At temp1,mouseY,CHR(SaveChar);
mouseX=temp2
Gosub GetCharAndAtribute
Color Red,Yellow
Print At temp2,mouseY,CHR(SaveChar);
End Sub

Sub DisplayByteAtMemLoc
Dim DFVal As Word
Dim DAcc As Word=CPUBusValue
Dim PatternPtr As Byte=scanline+1
Dim PatternYpos As Byte
PatternPtr=PatternPtr MODULO 4
If PatternPtr=1 Then
  Dim SavePatternPtr As Byte=161
Else
  If PatternPtr=2 Then
    SavePatternPtr=162
  Else
    If PatternPtr=3 Then
      SavePatternPtr=164
    Else
      SavePatternPtr=168
    End If
  End If
End If
For i=0 To 15 Step 2
  Dim PatternXpos As Byte=CDP1861Xpos+i
  [V00]=PatternXpos
  [V01]=PatternYpos
  CHIP16BEGIN
  > LCAT V00 V01
  CHIP16END
  LCAT_Val=[V00]
  DAcc = DAcc <<SHIFT 1
  DFVal = DAcc And 256
  PatternPtr=SavePatternPtr
  If DFVal = 256 Then
    PatternPtr=PatternPtr Or LCAT_Val
  Else
    If PatternPtr=161 Then
      PatternPtr=LCAT_Val And $FE
    Else
      If PatternPtr=162 Then
        PatternPtr=LCAT_Val And $FD
      Else
        If PatternPtr=164 Then
          PatternPtr=LCAT_Val And $FB
        Else
          PatternPtr=LCAT_Val And $F7
        End If
      End If
    End If
  End If
  Color(15)
  Print At PatternXpos,PatternYpos,CHR(PatternPtr),CHR(PatternPtr);
Next
End Sub

CHIP16BEGIN
@_KEYSHIFT
* B8 00 20 8E D8 B4 02 CD 16 A2 @_KEYSHIFTSTATUS
* CB 00 
@_KEYSHIFTSTATUS
* 00
@_FlushKeybdBuffer
* B8 00 0C CD 21 CB
@_GETKEY
* 1E 57 B8 00 20 8E D8 B8 @_SCANKEYCODE
* 8B F8 B4 01 CD 16 74 0D B4 00 CD 16 89 05 C6 45 02 FF EB 05 90 
@_NOKEY
* C6 45 02 00 
@_GETKEYEXIT
* 5F 1F CB 
@_SCANKEYCODE
* 00 00 
@_VALIDCODE
* 00 
@NEWCHAR0
* 00 00 00 00 00 00 00 00
* 00 00 00 00 00 00 00 00
@NEWCHAR1
* FF FF FF FF 00 00 00 00
* 00 00 00 00 00 00 00 00
@NEWCHAR2
* 00 00 00 00 FF FF FF FF
* 00 00 00 00 00 00 00 00
@NEWCHAR3
* FF FF FF FF FF FF FF FF
* 00 00 00 00 00 00 00 00
@NEWCHAR4
* 00 00 00 00 00 00 00 00
* FF FF FF FF 00 00 00 00
@NEWCHAR5
* FF FF FF FF 00 00 00 00
* FF FF FF FF 00 00 00 00
@NEWCHAR6
* 00 00 00 00 FF FF FF FF
* FF FF FF FF 00 00 00 00
@NEWCHAR7
* FF FF FF FF FF FF FF FF
* FF FF FF FF 00 00 00 00
@NEWCHAR8
* 00 00 00 00 00 00 00 00
* 00 00 00 00 FF FF FF FF
@NEWCHAR9
* FF FF FF FF 00 00 00 00
* 00 00 00 00 FF FF FF FF
@NEWCHAR10
* 00 00 00 00 FF FF FF FF
* 00 00 00 00 FF FF FF FF
@NEWCHAR11
* FF FF FF FF FF FF FF FF
* 00 00 00 00 FF FF FF FF
@NEWCHAR12
* 00 00 00 00 00 00 00 00
* FF FF FF FF FF FF FF FF
@NEWCHAR13
* FF FF FF FF 00 00 00 00
* FF FF FF FF FF FF FF FF
@NEWCHAR14
* 00 00 00 00 FF FF FF FF
* FF FF FF FF FF FF FF FF
@NEWCHAR15
* FF FF FF FF FF FF FF FF
* FF FF FF FF FF FF FF FF
CHIP16END
**